/**************************
	Google Calendar
	By Neo101
	Version 2.0.0
**************************/


var SECURITY_ID = max_security_id
var PLUGIN_NAME = 'Google Calendar'

var firstRun = MaxLib.checkSettingsFile()
if(firstRun == true){
	var showSettings = true
} else {
	var showSettings = false
}

var eventsArray = new Array()
var monthCalendarLoaded = false
var calendar
var SPECIAL_DAYS = {}

var settings = {
	emailAddress : decodeURIComponent( decodeTxt( MaxLib.readSetting('EmailAddress') ) ),
	password : decodeTxt( MaxLib.readSetting('Password') ),
	selectedCalendar : decodeTxt( MaxLib.readSetting('SelectedCalendar') ),
	authKey : decodeTxt( MaxLib.readSetting('authKey') ),

	expandToday : MaxLib.readSetting('expandToday'),
	expandTomorrow : MaxLib.readSetting('expandTomorrow'),
	expandRecentlyModified : MaxLib.readSetting('expandRecentlyModified'),
	expandPostForm : MaxLib.readSetting('expandPostForm'),
	
	autoCollapse : MaxLib.readSetting('autoCollapse'),

	maxNumberOfEvents : 10
}


if(settings.emailAddress == '' || settings.password == ''){
	showSettings = true
}


if(settings.emailAddress != '' && settings.emailAddress.search(/@/) == -1){
	settings.emailAddress = settings.emailAddress + '@gmail.com'
}

if(settings.selectedCalendar == ''){
	settings.selectedCalendar = settings.emailAddress
}


window.onload = function(){
	var formData = getEmptyFormObject()
	setForm(formData)
	setSettingsForm()

	setExpandCollapseStates()

	if(showSettings == true){
		displaySettings()
	}
	else {
		if(settings.authKey == ''){
			gData.login()
		} else {
			gData.viewFeeds()
		}
	}
}



/****************** Post Event **********************/

function checkAndPostEvent(){
	var whatValue = document.getElementById('what').value
	if(whatValue == ''){
		MaxLib.showError('Please insert an event!')
		return
	}
	
	var form = getEventForm()
	
	/*var dates = new Dates
	if(dates.today > form.whenStartDate){
		MaxLib.showError('Event can not be added to the past!\nCheck your dates.')
	}*/
	
	var data = gData.message(form)
	
	try{
		var selectedCalendar = document.getElementById('selectedCalendarPost').value
	} catch(err){
		MaxLib.showError('Selected Calendar could not be found!')
		var selectedCalendar = settings.selectedCalendar
	}
	
	if(document.getElementById('postURL').value != ''){
		var url = document.getElementById('postURL').value
	} else {
		var url = undefined
	}
	
	gData.postEvent(selectedCalendar, data, url)
}


/****************** Quick Add **********************/


function quickAdd(element){
	var text = element.value
	
	if(text == ''){
		MaxLib.showError('Please enter an event')
		return
	}
	
	var match1 = text.match(/(.*?) ([12]?\d ?(am|pm)|[12]?\d(:|\.)\d\d)/i) //|[12]?\d
	var match2 = text.match(/([12]?\d ?(am|pm)|[12]?\d(:|\.)\d\d) (.*)/i)
	if(match1){
		var time = match1[2]
		var what = match1[1]
	}
	else if(match2){
		var time = match2[1]
		var what = match2[4]
	}
	else {
		MaxLib.showError('sorry, no idea what you mean')
		return
	}
	
	var data = getEmptyFormObject()
	var date = new Dates()
	
	if(text.search(/tomorrow/i) != -1){
		data.whenStartDate = date.tomorrow
		data.whenEndDate = date.tomorrow
		what = what.replace(/tomorrow/i, '')
	}
	else if(text.search(/today/) != -1){
		data.whenStartDate = date.today
		data.whenEndDate = date.today
		what = what.replace(/today/i, '')
	} else {
		data.whenStartDate = date.today
		data.whenEndDate = date.today
	}
	
	var match = time.match(/([12]?\d) ?am/i)
	if(match){
		data.whenStartHour = MaxLib.timeToString(match[1]) + ':00'
		data.whenEndHour = MaxLib.timeToString(match[1]) + ':00'
	}
	match = time.match(/(1?\d) ?pm/i)
	if(match){
		data.whenStartHour = (parseInt(match[1]) + 12) + ':00'
		data.whenEndHour = (parseInt(match[1]) + 12) + ':00'
	}
	match = time.match(/([12]?\d(:|\.)\d\d)/i)
	if(match){
		data.whenStartHour = MaxLib.timeToString(match[1], 4).replace(/\./g,':')
		data.whenEndHour = MaxLib.timeToString(match[1], 4).replace(/\./g,':')
	}
	
	
	data.what = what	
	
	//data.whenStartHour = date.nextHour + ':00'
	//data.whenEndHour = date.next2Hour + ':00'
	
	data.fullStartDate = data.whenStartDate + 'T' + data.whenStartHour + ':00.000'
	data.fullEndDate = data.whenEndDate + 'T' + data.whenEndHour + ':00.000'
	
	
	var data = gData.message(data)
	gData.postEvent(settings.selectedCalendar, data)
}


/****************** Output Data **********************/


function createCalendarSelects(calendarArray){
	var selectHTMLconfig = '<select id="selectedCalendarConfig" onchange="onCalendarChange(this)">'
	for(var i=0; i<calendarArray.length; i++){
		if(calendarArray[i].link == settings.selectedCalendar){
			selectHTMLconfig += '<option value="' + calendarArray[i].link + '" selected>' + calendarArray[i].title + '</option>'
		} else {
			selectHTMLconfig += '<option value="' + calendarArray[i].link + '">' + calendarArray[i].title + '</option>'
		}
	}
	selectHTMLconfig += '</select>'

	var selectHTMLpost = '<select id="selectedCalendarPost">'
	for(var i=0; i<calendarArray.length; i++){
		if(calendarArray[i].accessLevel == 'owner' || calendarArray[i].accessLevel == 'contributor'){
			if(calendarArray[i].link == settings.selectedCalendar){
				selectHTMLpost += '<option value="' + calendarArray[i].link + '" selected>' + calendarArray[i].title + '</option>'
			} else {
				selectHTMLpost += '<option value="' + calendarArray[i].link + '">' + calendarArray[i].title + '</option>'
			}
		}
	}
	selectHTMLpost += '</select>'

	document.getElementById('selectedCalendarConfigDiv').innerHTML = selectHTMLconfig
	document.getElementById('selectedCalendarPostDiv').innerHTML = selectHTMLpost
}


function createEventsHtml(feedName, events, element){
	document.getElementById('user').innerHTML = feedName
	
	var response = ''
	
	if(events.length == 0){
		response += '<ul><li><b>No events found</b></li></ul>'
	} else {	
		response += writeFeedHtml( events , element)
	}
	
	document.getElementById(element).innerHTML = response
}

function writeFeedHtml( array , name){
	var response = '<ul>'
	var mainTime, title, name, details, detailedInfo, detailedTime
	var MAX_DESCRIPTION_LENGTH = 400
	
	for(var i=0; i<array.length ; i++){
		var mainTime = name == 'recentlyModified' ? array[i].whenStart.substring(5,16).replace(/T/,' ') : array[i].whenStart.substring(11, 16)
		if(mainTime == ''){
			mainTime = 'All Day'
		}
		detailedTime = '<label>Start:</label> ' + array[i].whenStart.substring(0,16) + 
						'<br><label>End:</label> ' + array[i].whenEnd.substring(0,16)
		detailedTime = detailedTime.replace(/T/g,' ')
		
		details = array[i].description.replace(/<.*?>/g,'').replace(/\n/g,'<br>')
		if(details.length > MAX_DESCRIPTION_LENGTH){
			details = details.substring(0, MAX_DESCRIPTION_LENGTH) + '...'
		}
		
		detailedInfo = detailedTime
		if(array[i].where != ''){
			detailedInfo += '<br><label>Where:</label> '+array[i].where
		}
		if(details == ''){
			details = detailedInfo
		} else {
			details = detailedInfo + '<br><label>Description:</label><br>' + details
		}
		details += '<br><a href="javascript:editEvent(' + array[i].number + ')">Edit</a>'
		details += ' | <a href="javascript:deleteEvent(' + array[i].number + ')">Delete</a>'
		details += ' | <a href="' + array[i].viewURL + '" target=_blank>Online &raquo;</a>'
		
		title = array[i].title
		
		response += '<li>'+
						'<div onclick="expandCollapse(this)" class=event>'+
								'<span class="eventTime">' + mainTime + '</span> <b>' + title + '</b>'+
						'<\/div>'+
						'<div style="display:none" id="item' + name + i + '" class=eventDetails>'+
							details+
						'<\/div>'+
					'<\/li>';
	}
	response += '<\/ul>'
	
	return response
}



/****************** Event Form **********************/


function getEmptyFormObject(){
	var date = new Dates()

	var result = {}
	
	result.what = ''
	result.where = ''
	result.description = ''	
	result.whenStartDate = date.today
	result.whenEndDate = date.today
	result.whenStartHour = date.nextHour + ':00'
	result.whenEndHour = date.next2Hour + ':00'
	
	return result
}


function getEventForm(){
	var result = {}
	
	result.what = document.getElementById('what').value
	result.where = document.getElementById('where').value
	result.description = document.getElementById('description').value
	result.whenStartDate = document.getElementById('whenStartDate').value
	result.whenEndDate = document.getElementById('whenEndDate').value
	result.whenStartHour = document.getElementById('whenStartHour').value
	result.whenEndHour = document.getElementById('whenEndHour').value
	
	result.fullStartDate = result.whenStartDate + 'T' + result.whenStartHour + ':00.000'
	result.fullEndDate = result.whenEndDate + 'T' + result.whenEndHour + ':00.000'
	
	return result
}


function setForm(data, url){
	document.getElementById('what').value = gData.xmlToString( data.what )
	document.getElementById('where').value = gData.xmlToString( data.where )
	document.getElementById('description').value = gData.xmlToString( data.description )
	
	document.getElementById('whenStartDate').value = data.whenStartDate
	document.getElementById('whenEndDate').value = data.whenEndDate
	document.getElementById('whenStartHour').value = data.whenStartHour
	document.getElementById('whenEndHour').value = data.whenEndHour
	
	if(url){
		document.getElementById('postURL').value = url
	} else {
		document.getElementById('postURL').value = ''
	}
}


/****************** Display **********************/


function displaySettings(){
	document.getElementById('calendar').style.display = 'none'
	document.getElementById('settings').style.display = ''
	document.getElementById('message').style.display = 'none'
	document.getElementById('emailAddress').focus()
}


function hideSettings(){
	document.getElementById('calendar').style.display = ''
	document.getElementById('settings').style.display = 'none'
	document.getElementById('message').style.display = 'none'
}


function setSettingsForm(){
	document.getElementById('emailAddress').value = decodeURIComponent( settings.emailAddress )
	document.getElementById('password').value = decodeURIComponent( settings.password )
}


function setExpandCollapseStates(){
	if(settings.expandToday == '1'){
		expandCollapse( document.getElementById('todayHead') , true)
	}
	if(settings.expandTomorrow == '1'){
		expandCollapse( document.getElementById('tomorrowHead') , true)
	}
	if(settings.expandRecentlyModified == '1'){
		expandCollapse( document.getElementById('recentlyModifiedHead') , true)
	}
}


/****************** Convert Objects **********************/

function convertEventFromAtom(object){
	var result = {}
	
	result.what = object.title
	result.where = object.where
	result.description = object.description
	try{
		result.whenStartDate = object.whenStart.split('T')[0]
		result.whenEndDate = object.whenEnd.split('T')[0]
		result.whenStartHour = object.whenStart.split('T')[1].substring(0,5)
		result.whenEndHour = object.whenEnd.split('T')[1].substring(0,5)
	} catch(err){
		result.whenStartDate = object.whenStart
		result.whenEndDate = object.whenEnd
		result.whenStartHour = '00:00'
		result.whenEndHour = '00:00'
	}
	
	result.fullStartDate = result.whenStartDate + 'T' + result.whenStartHour + ':00.000'
	result.fullEndDate = result.whenEndDate + 'T' + result.whenEndHour + ':00.000'
	result.id = object.id
	
	return result
}

function dateIsSpecial(year, month, day) {
	var y = SPECIAL_DAYS[year];
	if( !y ){
		SPECIAL_DAYS[year] = {};
		return false;
	}
	var m = y[month];
	if (!m) return false;
	for (var i in m){
		if (m[i] == day) return true;
	}
	return false;
};


function ourDateStatusFunc(date, y, m, d) {
	if (dateIsSpecial(y, m, d)){
		return "special";
	}
	else
		return false; // other dates are enabled
	// return true if you want to disable other dates
};


function Dates(){
	var dateToday = new Date()
	var year = dateToday.getFullYear()
	var month = MaxLib.timeToString( dateToday.getMonth() + 1 )
	var day = MaxLib.timeToString( dateToday.getDate() )
	var dayTomorrow = MaxLib.timeToString( dateToday.getDate() + 1 )
	var dayPastTomorrow = MaxLib.timeToString( dateToday.getDate() + 2 )
	var hour = dateToday.getHours()
	
	this.today = year + '-' + month + '-' + day
	this.tomorrow = year + '-' + month + '-' + dayTomorrow
	this.pastTomorrow = year + '-' + month + '-' + dayPastTomorrow
	
	this.nextHour = MaxLib.timeToString( hour + 1 )
	this.next2Hour = MaxLib.timeToString( hour + 2 )
	
	this.firstDayOfMonth = function(month, year){
		return year + '-' + MaxLib.timeToString(month) + '-' + '01'
	}
}


/****************** Encryption **********************/

//Thanks to http://scriptasylum.com for the encoder/decoder!

function encodeTxt(s){
	s=escape(s);
	var ta=new Array();
	for(var i=0;i<s.length;i++){
		ta[i]=s.charCodeAt(i)+1;
	}
	return ""+escape(eval("String.fromCharCode("+ta+")"))+1;
}


function decodeTxt(s){
	var s1=unescape(s.substr(0,s.length-1));
	var t='';
	for(var i=0;i<s1.length;i++){
		t+=String.fromCharCode(s1.charCodeAt(i)-s.substr(s.length-1,1));
	}
	return unescape(t);
}
