/**************************
	Google Calendar
	By Neo101
	Version 2.0.0
**************************/


var gData = {

loginCalled : false,
authURL : 'https://www.google.com/accounts/ClientLogin',
//calendarListLoaded : false,


viewFeeds : function(){
	this.viewTodayFeed()
	this.viewTomorrowFeed()
	this.viewRecentFeed()
	//if(this.calendarListLoaded == false){
	//	this.calendarListLoaded = true
	this.getAllCalendars()
	//}
},


/****************** Login **********************/


login : function(){
	var url = this.authURL + '?Email='+settings.emailAddress+'&Passwd='+settings.password+'&source=Maxthon-GoogleCalendar-2&service=cl'
	
	var callBack = {'onFailure': this.onFailure, 'onSuccess': this.onResponseLogin}
	
	var number = ajaxLib.openConnection(url, 'get', callBack, null)
	
	ajaxLib.makeCall( number )
},

onResponseLogin : function(text, object){
	try{
		text = text.split('\n')
	} catch(err){
		MaxLib.showError('Error 266: login response error. Response: ' + text)
	}
	settings.authKey = text[2].substring(5,999)
	MaxLib.writeSetting('authKey', encodeTxt(settings.authKey))
	gData.viewFeeds()
},


/****************** View Events **********************/


viewRecentFeed : function(){
	var feedURL = 'http://www.google.com/calendar/feeds/'+settings.selectedCalendar+'/private/full?max-results=' + settings.maxNumberOfEvents
	
	var callBack = {'onFailure': this.onFailure, 'onSuccess': this.onResponseView, 'element' : 'recentlyModified'}
	
	var number = ajaxLib.openConnection(feedURL, 'get', callBack, null)
	ajaxLib.setHeader( number, "Authorization", "GoogleLogin auth="+settings.authKey)
	ajaxLib.makeCall( number )
},


viewTodayFeed : function(){
	var date = new Dates()
	
	var startDate = date.today
	var endDate = date.tomorrow
	
	var feedURL = 'http://www.google.com/calendar/feeds/'+settings.selectedCalendar+'/private/full?start-min='+startDate+'&start-max='+endDate
	
	var callBack = {'onFailure': this.onFailure, 'onSuccess': this.onResponseView, 'element' : 'today'}
	
	var number = ajaxLib.openConnection(feedURL, 'get', callBack, null)
	ajaxLib.setHeader( number, "Authorization", "GoogleLogin auth="+settings.authKey)
	ajaxLib.makeCall( number )
},


viewTomorrowFeed : function(){
	var date = new Dates()
	
	var startDate = date.tomorrow
	var endDate = date.pastTomorrow
	
	var feedURL = 'http://www.google.com/calendar/feeds/'+settings.selectedCalendar+'/private/full?start-min='+startDate+'&start-max='+endDate+ '&orderby=starttime'
	
	var callBack = {'onFailure': this.onFailure, 'onSuccess': this.onResponseView, 'element' : 'tomorrow'}
	
	var number = ajaxLib.openConnection(feedURL, 'get', callBack, null)
	ajaxLib.setHeader( number, "Authorization", "GoogleLogin auth="+settings.authKey)
	ajaxLib.makeCall( number )
},


viewOneDayFeed : function(day, month, year){
	var date = new Dates()
	
	var startDate = year + '-' + MaxLib.timeToString(month) + '-' + MaxLib.timeToString(day)
	var endDate = year + '-' + MaxLib.timeToString(month) + '-' + MaxLib.timeToString(day + 1)
	
	var feedURL = 'http://www.google.com/calendar/feeds/'+settings.selectedCalendar+'/private/full?start-min='+startDate+'&start-max='+endDate+ '&orderby=starttime'
	
	var callBack = {'onFailure': this.onFailure, 'onSuccess': this.onResponseView, 'month':month, 'year': year, 'day': day, 'element':'oneDay'}
	
	var number = ajaxLib.openConnection(feedURL, 'get', callBack, null)
	ajaxLib.setHeader( number, "Authorization", "GoogleLogin auth="+settings.authKey)
	ajaxLib.makeCall( number )
},


onResponseView : function(responseText, object){
	var objXMLDOM = new ActiveXObject("Microsoft.XMLDOM")
	objXMLDOM.async = false 
	
	objXMLDOM.loadXML(responseText) 
	var responseXML = objXMLDOM.documentElement 

	if(responseXML == null){
		MaxLib.showError('Error 318: Could not parse feed <br>'+
		'Make sure <a href="http://www.google.com/calendar" target=_blank>www.google.com/calendar</a> is working')
		return
	}
	
	try{
		var feedName = responseXML.getElementsByTagName('title')[0].text;
	}
	catch(err){
		var feedName = ''
	}	
	
	var events = new Array()
	items = responseXML.getElementsByTagName("entry")
	
	if(items && items.length != 0){
		for(var j=0; j < items.length; j++) {
			gData.addFeedItem(items[j], events, j + eventsArray.length)
		}
	}
	
	eventsArray = eventsArray.concat(events)
	
	if(object.callBack.element != 'recentlyModified'){
		events.sort(gData.sortTime)
	}
	
	createEventsHtml(feedName, events, object.callBack.element)
},


/****************** View month events **********************/


getMonthList : function(month, year){
	var date = new Dates()
	
	var startDate = date.firstDayOfMonth(month, year)
	var endDate = date.firstDayOfMonth(month + 1 % 11, year)
	
	var feedURL = 'http://www.google.com/calendar/feeds/'+settings.selectedCalendar+'/private/free-busy?start-min='+startDate+'&start-max='+endDate + '&orderby=starttime'
	
	var callBack = {'onFailure': this.onFailure, 'onSuccess': this.onResponseMonthList, 'month':month, 'year': year}
	
	var number = ajaxLib.openConnection(feedURL, 'get', callBack, null)
	ajaxLib.setHeader( number, "Authorization", "GoogleLogin auth="+settings.authKey)
	ajaxLib.makeCall( number )
},


onResponseMonthList : function(responseText, object){
	var objXMLDOM = new ActiveXObject("Microsoft.XMLDOM")
	objXMLDOM.async = false 
	
	objXMLDOM.loadXML(responseText) 
	var responseXML = objXMLDOM.documentElement
	if(responseXML == null){
		MaxLib.showError('Error: responseXML is null')
		return
	}
	var events = new Array()
	items = responseXML.getElementsByTagName("entry")
	
	if(items && items.length != 0 ){
		for(var j=0; j < items.length; j++) {
			gData.addFeedItem(items[j], events, j)
		}
	}
	
	var dayArray = new Array()
	
	for(var i=0; i<events.length; i++){
		if(events[i].whenStart.substring(5, 7) == object.callBack.month){
			dayArray.push(events[i].whenStart.substring(8, 10))
		}
	}
	
	SPECIAL_DAYS[object.callBack.year][object.callBack.month-1] = dayArray
	document.getElementById('monthCalendarLoading').style.display = 'none'
	calendar.refresh()
},


/****************** Get Calendars **********************/

getAllCalendars : function(){
	var feedURL = 'http://www.google.com/calendar/feeds/'+settings.emailAddress
	
	var callBack = {'onFailure': this.onFailure, 'onSuccess': this.onResponseGetAllCalendars}
	
	var number = ajaxLib.openConnection(feedURL, 'get', callBack, null)
	ajaxLib.setHeader( number, "Authorization", "GoogleLogin auth="+settings.authKey)
	ajaxLib.makeCall( number )
},


onResponseGetAllCalendars : function(responseText){
	var objXMLDOM = new ActiveXObject("Microsoft.XMLDOM")
	objXMLDOM.async = false
	
	objXMLDOM.loadXML(responseText)
	var responseXML = objXMLDOM.documentElement
	
	if(responseXML == null){
		MaxLib.showError('Error 250: Could not parse feed <br>'+
		'Make sure <a href="http://www.google.com/calendar" target=_blank>www.google.com/calendar</a> is working')
		return
	}
	
	items = responseXML.getElementsByTagName("entry")

	var calendarArray = new Array()

	if(items && items.length != 0 ){
		for(var j=0; j < items.length; j++) {
			gData.addCalendar(items[j], calendarArray)
		}
	}
	
	createCalendarSelects(calendarArray)
},


addCalendar : function( item , array){
	var title = ''
	var id = ''
	var accessLevel = ''
	var link = ''
	
	var nodes = item.childNodes
	
	for(var i=0; i < nodes.length; i++){
		var tagName = nodes(i).tagName
		var tagText = nodes(i).text
		if(tagName=='title'){
			title = gData.replacer(tagText)
		}
		else if(tagName=='link') {
			if( item.childNodes(i).getAttribute("rel") == 'alternate'){
				link = item.childNodes(i).getAttribute("href")
			}
		} 
		else if(tagName=='id') {
			id = tagText
		} 
		else if(tagName=='gCal:accesslevel'){
			accessLevel = item.childNodes(i).getAttribute("value")
		}
	}

	
	//filter from 'http://www.google.com/calendar/feeds/<<KeepThis>>/private/full' to '<<KeepThis>>'
	link = link.replace(/.*?\/feeds\//,'').replace(/\/private\/full/,'')
	
	if(title != '' && id != ''){
		array.push( {'title':title,
					'id':id,
					'accessLevel':accessLevel,
					'link':link
					} )
	}
},


/****************** Post event **********************/

postEvent : function(selectedCalendar, data, postURL){
	if(postURL == null){
		var postURL = 'http://www.google.com/calendar/feeds/'+selectedCalendar+'/private/full'
		var method = 'post'
	} else {
		var method = 'put'
	}

	var callBack = {'onFailure': this.onFailure, 'onSuccess': this.onResponsePost}
	
	var number = ajaxLib.openConnection(postURL, method, callBack, data)
	ajaxLib.setHeader( number, "Authorization", "GoogleLogin auth="+settings.authKey)
	ajaxLib.setHeader( number, "Content-Type", "application/atom+xml")
	ajaxLib.makeCall( number )
},


onResponsePost : function(){
	MaxLib.showError('Event Posted!')
	gData.viewFeeds()
	setForm( getEmptyFormObject() )
	clickTab(1)
},



/****************** Delete event **********************/


deleteEvent : function(postURL){
	var callBack = {'onFailure': this.onFailure, 'onSuccess': this.onResponseDelete}
	
	var number = ajaxLib.openConnection(postURL, 'delete', callBack, null)
	ajaxLib.setHeader( number, "Authorization", "GoogleLogin auth="+settings.authKey)
	ajaxLib.makeCall( number )
},


onResponseDelete : function(){
	MaxLib.showError('Event Deleted!')
	gData.viewFeeds()
},





/****************** Main functions **********************/

message : function(data){
	var text = "<entry xmlns='http://www.w3.org/2005/Atom' xmlns:gd='http://schemas.google.com/g/2005'>"+
				"<category scheme='http://schemas.google.com/g/2005#kind' term='http://schemas.google.com/g/2005#event' />"+
				"<title type='text'>"+gData.stringToXml(data.what)+"</title>"+
				"<content type='text'>"+gData.stringToXml(data.description)+"</content>"+
				"<author>"+
					"<name>"+encodeURIComponent(settings.emailAddress)+"</name>"+
					"<email>"+encodeURIComponent(settings.emailAddress)+"</email>"+
				"</author>"+
				"<gd:transparency value='http://schemas.google.com/g/2005#event.opaque' />"+
				"<gd:eventStatus value='http://schemas.google.com/g/2005#event.confirmed' />"+
				"<gd:where valueString='"+gData.stringToXml(data.where)+"' />"+
				"<gd:when startTime='"+data.fullStartDate+"' endTime='"+data.fullEndDate+"' />"+
			"</entry>"
	//alert(text) //debug
	return text
},


onFailure: function(object){
	if(object.object.status == 401 || object.object.status == 403){
		if(object.object.responseText.search(/token invalid/i) != -1){
			if(gData.loginCalled == false){
				gData.loginCalled = true
				gData.login()
			}
		} else {
			var message = 'Access denied error...'
			document.getElementById('today').innerHTML = message
			document.getElementById('tomorrow').innerHTML = message
			document.getElementById('recentlyModified').innerHTML = message
			MaxLib.showError('Could not login. Please check your account settings')
		}
	}
	else if(object.object.status == 400){
		MaxLib.showError('Error 400: Bad request<br />' + object.object.responseText)
	}
	/*else if(object.object.status == 500){
		MaxLib.showError('Make sure <a href="http://www.google.com/calendar" target=_blank>www.google.com/calendar</a> is working')
	}*/
	else{
		if(gData.loginCalled == false && object.object.getResponseHeader("WWW-authenticate") != ''){
			gData.loginCalled = true
			gData.login()
		} else {
			MaxLib.showError('Connection error ' + object.object.status + ' ' + object.object.statusText);
		}
	}
	
	//alert(object.object.responseText) //debug
},



addFeedItem : function( item , array, number){
	var title = ''
	var editURL = ''
	var description = ''
	var whenStart = ''
	var whenEnd = ''
	var where = ''
	
	var nodes = item.childNodes
	
	for(var i=0; i < nodes.length; i++){
		var tagName = nodes(i).tagName
		var tagText = nodes(i).text
		if(tagName=='title'){
			title = gData.replacer(tagText)
		}
		else if(tagName=='link' && item.childNodes(i).getAttribute("rel") == 'edit') {
			editURL = nodes(i).getAttribute('href')
		}
		else if(tagName=='link' && item.childNodes(i).getAttribute("rel") == 'alternate') {
			viewURL = nodes(i).getAttribute('href')
		}
		else if(tagName=='content'){
			description = gData.replacer(tagText)
		}
		else if(tagName=='gd:when'){
			if( item.childNodes(i).getAttribute("startTime") != '' ){
				whenStart = gData.replacer( item.childNodes(i).getAttribute("startTime") )
				whenEnd = gData.replacer( item.childNodes(i).getAttribute("endTime") )
			}
		}
		else if(tagName=='gd:where'){
			var string = item.childNodes(i).getAttribute("valueString")
			if( string && string != '' ){
				where = gData.replacer( string )
			}
		}
	}
	
	array.push( {'title':title,
				'editURL':editURL,
				'viewURL':viewURL,
				'description':description,
				'whenStart': whenStart,
				'whenEnd': whenEnd,
				'where': where,
				'number': number
				} )
},


sortTime : function(a,b){ //alert(a.whenStart + '\n' + b.mainTime)
	return a.whenStart < b.whenStart ? -1 : 1
},


replacer: function(string){
	return string//.replace(/</g,'&lt;').replace(/>/g,'&gt;');
},

stringToXml: function(string){
	return string.replace(/</g,'&lt;').replace(/>/g,'&gt;').replace(/&/g,'&amp;');
},

xmlToString: function(string){
	return string.replace(/&lt;/g,'<').replace(/&gt;/g,'>').replace(/&amp;/g,'&');
}


}