/**************************
	Google Calendar
	By Neo101
	Version 2.0.0
**************************/

var openItem

function expandCollapse(titleElement, noWrite){
	var elementId = titleElement.nextSibling.id
	var element = document.getElementById(elementId)
	var itemName = 'Expand' + elementId

	if(element.style.display == 'none'){
		element.style.display = 'block'
		if(noWrite == null){
			saveState(itemName, '1')
		}
		if(settings.autoCollapse == '1' && elementId.substring(0,4) == 'item' ){
			if(openItem){
				try{
					expandCollapse(openItem)
				} catch(e) {}
			}
			openItem = titleElement
		}
	}
	else{
		element.style.display = 'none'
		if(noWrite == null){
			saveState(itemName, '0')
		}
		openItem = null
	}
}


function saveState(itemName, state){
	if(itemName.search(/item/) == -1){
		MaxLib.writeSetting(itemName, state)
	}
}


function clickTab(activeTabNumber){
	var nodes = document.getElementsByTagName('div');
	
	for(var i=0; i<nodes.length; i++){
		if(nodes[i].id.indexOf('data') == 0){
			nodes[i].style.display = 'none'
		}
	}
	
	var nodes = document.getElementsByTagName('span');
	
	for(var i=0; i<nodes.length; i++){
		if(nodes[i].id.indexOf('tab') == 0){
			nodes[i].className = 'unselected-tab'
		}
	}
	
	if(activeTabNumber == 3 && monthCalendarLoaded == false){
		loadCalendar()
	}
	
	document.getElementById("tab" + activeTabNumber).className = 'selected-tab'
	document.getElementById("data" + activeTabNumber).style.display = 'block'
	
	if(activeTabNumber == 2){
		document.getElementById('quickAdd').focus()
	}
	
	MaxLib.hideError()
}


function loadCalendar(){
	monthCalendarLoaded = true

	calendar = Calendar.setup(
		{
		  flat         : "calendar-container", // ID of the parent element
		  flatCallback : dateChanged,          // our callback function
		  dateStatusFunc : ourDateStatusFunc,
		  range : [2005, 2010]
		}
	  );
	gData.getMonthList(calendar.date.getMonth() + 1, calendar.date.getFullYear())
}


function onCalendarChange(selectObject){
	settings.selectedCalendar = selectObject.value
	
	MaxLib.writeSetting('SelectedCalendar', encodeTxt(settings.selectedCalendar) )
	
	var message = 'loading...'
	document.getElementById('recentlyModified').innerHTML = message
	document.getElementById('today').innerHTML = message
	document.getElementById('tomorrow').innerHTML = message

	gData.viewFeeds()
}


function goToEventForm(){
	var formData = getEmptyFormObject()
	formData.whenStartDate = calendar.date.getFullYear() + '-' + MaxLib.timeToString(calendar.date.getMonth() + 1) + 
								'-' + MaxLib.timeToString(calendar.date.getDate() )
	formData.whenEndDate = formData.whenStartDate
	setForm(formData)
	clickTab(2)
}


function cancelSettings(){
	hideSettings()
	
	if(settings.emailAddress == '' || settings.password == ''){
		var message = '<a href="javascript:displaySettings()">Login first!</a>'
		document.getElementById('user').innerHTML = message
		document.getElementById('today').innerHTML = message
		document.getElementById('tomorrow').innerHTML = message
	}
}


function saveSettings(){
	settings.emailAddress = encodeURIComponent( document.getElementById('emailAddress').value )
	settings.password = encodeURIComponent( document.getElementById('password').value )

	MaxLib.writeSetting('EmailAddress', encodeTxt( settings.emailAddress ))
	MaxLib.writeSetting('Password', encodeTxt( settings.password ))
	
	MaxLib.writeSetting('authKey', '')
	MaxLib.writeSetting('SelectedCalendar', '')

	location.reload()
}


function editEvent( number ){
	var formData = convertEventFromAtom(eventsArray[number])
	setForm(formData, eventsArray[number].editURL)
	clickTab(2)
}


function deleteEvent( number ){
	if( confirm('Are you sure you would like to delete this event?') ){
		gData.deleteEvent(eventsArray[number].editURL)
	}
}


function enterKeyPressConfig() {
	if (window.event.keyCode == 13){
		saveSettings()
	}
}


function enterKeyPressQuickAdd(element){
	if (window.event.keyCode == 13){
		quickAdd(element)
	}
}


function dateChanged(calendar) {
	if (calendar.dateClicked) {
		var year = calendar.date.getFullYear();
		var month = calendar.date.getMonth() + 1;
		var day = calendar.date.getDate();
		gData.viewOneDayFeed(day, month, year)
		document.getElementById('oneDay').innerHTML = 'Loading...'
	} else if(SPECIAL_DAYS[calendar.date.getFullYear()][calendar.date.getMonth()] == null){
		document.getElementById('monthCalendarLoading').style.display = ''
		gData.getMonthList(calendar.date.getMonth() + 1, calendar.date.getFullYear())
	}
};

function reloadMonthCalendar(){
	document.getElementById('monthCalendarLoading').style.display = ''
	gData.getMonthList(calendar.date.getMonth() + 1, calendar.date.getFullYear())
}

function checkDate(startDate){
	if(startDate.length < 10){
		return
	}
	var endDate = document.getElementById('whenEndDate').value
	if(startDate > endDate){
		document.getElementById('whenEndDate').value = startDate
	}
}